# -*- coding:Utf-8 -*-
# rank_cut V.1.106p by DoCky (23/01/2009)
# helped by EmbouT and Nicolous


import es, popuplib

info = es.AddonInfo()
info.author = "DoCky"
info.name = "rank_cut"
info.version = "1.106p"
info.url = "http://addons.eventscripts.com/addons/user/11751"

vers = es.ServerVar(info.name, "", "By DoCky -")
vers.set(info.version)
vers.makepublic()

acces = es.ServerVar("rc_acces")
title = es.ServerVar("rc_title")
empti = es.ServerVar("rc_empti")
playerlist = []
popuplist = []

class Joueur(object):
    def __init__(self, steamid, frag, name):
        self.steamid = steamid
        self.frag = frag
        self.name = name

    def __eq__(self, valeur):
        value = False
        if isinstance(valeur, Joueur): value = (self.frag == valeur.frag) and (self.name == valeur.name) and (self.steamid == valeur.steamid)
        else: value = valeur
        return value

    def __cmp__(self, joueur):
        return cmp(self.frag, joueur.frag)

    def __str__(self):
        return "%s [%s kill]" % (self.name, self.frag)

def load():
    es.server.cmd("es_xmexec ../addons/eventscripts/rank_cut/rank_cut.txt")
    es.regclientcmd(str(acces), "rank_cut/player_rank", "display rank cut menu")
    es.regsaycmd(str(acces), "rank_cut/player_rank", "display rank cut menu")

def unload():
    for menu in popuplist: popuplib.delete(menu)
    es.unregclientcmd(str(acces))
    es.unregsaycmd(str(acces))

def player_death(ev):
    if ev["weapon"] == "knife" and ev["es_attackersteamid"] != "BOT" and ev["es_attackersteamid"] != "STEAM_ID_PENDING" and ev["es_userteam"] != ev["es_attackerteam"]:
        if ev["es_attackersteamid"] in playerlist:
            joueur = playerlist[playerlist.index(ev["es_attackersteamid"])]
            joueur.name = ev["es_attackername"]
            joueur.frag += 1
        else: playerlist.append(Joueur(ev["es_attackersteamid"], 1, ev["es_attackername"]))

def player_rank():
    rank = []
    user = es.getcmduserid()
    name = "rank_cut_%s" % user

    popuplist.append(name)
    playerlist.sort(reverse = True)
    for joueur in playerlist: rank.append(str(joueur))
    if not rank: rank = (str(empti),)

    if popuplib.exists(name): popuplib.delete(name)
    rank_cut = popuplib.easylist(name, rank)
    rank_cut.settitle(str(title))
    rank_cut.send(user)
